#ifdef STATISTICS
/*
 * $Id: Update_Prediction_Table_statistics_deallocation.cpp 97 2008-12-19 15:34:00Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
#include "Behavioural/include/Allocation.h"

namespace morpheo {
namespace behavioural {
namespace core {
namespace multi_front_end {
namespace front_end {
namespace prediction_unit {
namespace update_prediction_table {


#undef  FUNCTION
#define FUNCTION "Update_Prediction_Table::statistics_deallocation"
  void Update_Prediction_Table::statistics_deallocation (void)
  {
    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"Begin");

    log_printf(INFO,Update_Prediction_Table,FUNCTION,"Generate Statistics file");
    
    delete    _stat;

    DELETE2(_stat_nb_branch_hit            ,_param->_nb_context,MAX_BRANCH_CONDITION);
    DELETE2(_stat_nb_branch_miss           ,_param->_nb_context,MAX_BRANCH_CONDITION);
    DELETE1(_stat_nb_branch_unused         ,_param->_nb_context);
    DELETE1(_stat_ufpt_queue_nb_elt        ,_param->_nb_context);
    DELETE1(_stat_upt_queue_nb_elt         ,_param->_nb_context);
    
    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
  };

}; // end namespace update_prediction_table
}; // end namespace prediction_unit
}; // end namespace front_end
}; // end namespace multi_front_end
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
